com.holonplatform.core

## Interface Expression

- All Known Subinterfaces:
    Aliasable.AliasablePath<T,C>, BeanDataTarget<T>, BeanProjection<T>, BeanProperty<T>, BeanProperty.Builder<T>, BooleanBeanProperty, BooleanProperty, BooleanProperty.BooleanPropertyBuilder, BulkDeleteOperationConfiguration, BulkInsertOperationConfiguration, BulkUpdateOperationConfiguration, CloneableProperty<T,P,B>, CloneableProperty.CloneablePathProperty<T,P>, CollectionConstantExpression<T>, CollectionExpression<E,C>, CollectionPathProperty<E,C>, CollectionProperty<E,C>, CollectionProperty.ListProperty<T>, CollectionProperty.SetProperty<T>, ConstantConverterExpression<T,E>, ConstantExpression<T>, ConverterExpression<T>, CountAllProjection, DatastoreOperationConfiguration, DataTarget<T>, Join<T>, ListPathProperty<T>, ListPathProperty.ListPathPropertyBuilder<T>, ListVirtualProperty<T>, ListVirtualProperty.ListVirtualPropertyBuilder<T>, NullExpression<T>, NumericBeanProperty<N>, NumericProperty<N>, NumericProperty.NumericPropertyBuilder<N>, NumericQueryExpression<N>, Path<T>, Path.FinalPath<T>, Path.FinalPath.FinalPathBuilder<T>, Path.PathBuilder<T>, PathExpression<T>, PathProperty<T>, PathProperty.PathPropertyBuilder<T>, Property<T>, PropertyBoxOperationConfiguration, PropertyBoxProperty, PropertyBoxProperty.PropertyBoxPropertyBuilder, PropertySetProjection, QueryAggregation, QueryConfiguration, QueryExpression<T>, QueryFilter, QueryFilter.CompositeQueryFilter, QueryFunction<T,A>, QueryFunction.Avg, QueryFunction.Count, QueryFunction.Max<T>, QueryFunction.Min<T>, QueryFunction.NoArgQueryFunction<T>, QueryFunction.PropertyQueryFunction<T,A>, QueryFunction.Sum<T>, QueryOperation<C,R>, QueryProjection<T>, QuerySort, QuerySort.CompositeQuerySort, QuerySort.PathQuerySort<T>, RelationalTarget<T>, SelectAllProjection, SetPathProperty<T>, SetPathProperty.SetPathPropertyBuilder<T>, SetVirtualProperty<T>, SetVirtualProperty.SetVirtualPropertyBuilder<T>, StringBeanProperty, StringFunction, StringFunction.Lower, StringFunction.Upper, StringProperty, StringProperty.StringPropertyBuilder, StringQueryExpression, SubQuery<T>, TemporalBeanProperty<T>, TemporalFunction<T>, TemporalFunction.CurrentDate, TemporalFunction.CurrentLocalDate, TemporalFunction.CurrentLocalDateTime, TemporalFunction.CurrentTimestamp, TemporalFunction.Day, TemporalFunction.Hour, TemporalFunction.Month, TemporalFunction.Year, TemporalProperty<T>, TemporalProperty.TemporalPropertyBuilder<T>, TemporalQueryExpression<T>, TypedExpression<T>, VirtualProperty<T>, VirtualProperty.Builder<T,P,B>, VirtualProperty.VirtualPropertyBuilder<T>
  All Known Implementing Classes:
    AbstractConverterExpression, DefaultCollectionConstantExpression, DefaultConstantConverterExpression, DefaultFinalPath, DefaultNullExpression, DefaultPath

      public interface Expression

  Represents a generic expression with validation support.
  Since:
    5.0.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>` A function to translate an `Expression` into another `Expression` type.
    `static class` | `Expression.InvalidExpressionException` Exception related to {Expression} validation or resolution failures.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `validate()` Validate this expression.

- - ### Method Detail

    - #### validate

          void validate()
                 throws Expression.InvalidExpressionException

      Validate this expression.
      Throws:
        `Expression.InvalidExpressionException` - If the expression is not valid

Copyright © 2019 The Holon Platform. All rights reserved.